/* @(#)99       1.2  src/include/pos/device.h, apicode, ptuxrolo, 35 4/4/01 11:35:04 */

/********************************************************************/
/*  <device.h> header file                                          */
/*                                                                  */
/*  Licensed Materials - Property of IBM                            */
/*                                                                  */
/*  IBM Point of Sale Subsystem                                     */
/*  73G0950 (C) Copyright IBM Corporation 1992, 1998                */
/*  All rights reserved                                             */
/*                                                                  */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication, or disclosure restricted                      */
/*  by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                  */
/********************************************************************/

#ifndef _H_POS_DEVICE
#define _H_POS_DEVICE 1

/****************************/
/* PosDevice resource names */
/****************************/

#define PosNslotNumber                          "slotNumber"
#define PosNportNumber                          "portNumber"
#define PosNdeviceNumber                        "deviceNumber"
#define PosNqueueHandle                         "queueHandle"
#define PosNreadTimeout                         "readTimeout"
#define PosNdeviceName                          "deviceName"
#define PosNdeviceDescription                   "deviceDescription"
#define PosNaddressWaitTime                     "addressWaitTime"
#define PosNbyteWaitTime                        "byteWaitTime"
#define PosNecLevel                             "ecLevel"
#define PosNackWaitTime                         "ackWaitTime"
#define PosNvitalProductData                    "vitalProductData"
#define PosNcodePage                            "codePage"
#define PosNdeviceHost                          "deviceHost"
#define PosNserviceDescriptor                   "serviceDescriptor"


/******************************/
/* PosDevice resource classes */
/******************************/

#define PosCSlotNumber                          "SlotNumber"
#define PosCPortNumber                          "PortNumber"
#define PosCDeviceNumber                        "DeviceNumber"
#define PosCQueueHandle                         "QueueHandle"
#define PosCReadTimeout                         "ReadTimeout"
#define PosCDeviceName                          "DeviceName"
#define PosCDeviceDescription                   "DeviceDescription"
#define PosCAddressWaitTime                     "AddressWaitTime"
#define PosCByteWaitTime                        "ByteWaitTime"
#define PosCEcLevel                             "EcLevel"
#define PosCAckWaitTime                         "AckWaitTime"
#define PosCVitalProductData                    "VitalProductData"
#define PosCCodePage                            "CodePage"


/**********************************/
/* PosNslotNumber resource values */
/**********************************/

#define PosSLOT_0                               0
#define PosSLOT_1                               1
#define PosSLOT_2                               2
#define PosSLOT_3                               3
#define PosSLOT_4                               4
#define PosSLOT_5                               5
#define PosSLOT_6                               6
#define PosSLOT_7                               7
#define PosSLOT_8                               8


/**********************************/
/* PosNportNumber resource values */
/**********************************/

#define PosPORT_0                               0
#define PosPORT_1                               0x11
#define PosPORT_2                               0x22


/************************************/
/* PosNdeviceNumber resource values */
/************************************/


#define PosDEVICE_CHECKOUT_KEYBOARD_A           0x10
#define PosDEVICE_JAPANESE_KEYBOARD             0x10
#define PosDEVICE_CHECKOUT_KEYBOARD_B           0x11
#define PosDEVICE_TEXT_KEYBOARD_A               0x12
#define PosDEVICE_TEXT_KEYBOARD_B               0x13
#define PosDEVICE_MATRIX_KEYBOARD_A             0x16
#define PosDEVICE_MATRIX_KEYBOARD_B             0x17
#define PosDEVICE_PLU_KEYBOARD                  0x19
#define PosDEVICE_ANPOS_KEYBOARD_A              0x1A
#define PosDEVICE_ANPOS_KEYBOARD_B              0x1B
#define PosDEVICE_POS_KEYBOARD_A                0x1C
#define PosDEVICE_POS_KEYBOARD_B                0x1D
#define PosDEVICE_ALPHANUMERIC_DISPLAY_A        0x20
#define PosDEVICE_ALPHANUMERIC_DISPLAY_B        0x21
#define PosDEVICE_OPERATOR_DISPLAY_A            0x22
#define PosDEVICE_OPERATOR_DISPLAY_B            0x23
#define PosDEVICE_ANOP_DISPLAY_A                0x24
#define PosDEVICE_ANOP_DISPLAY_B                0x25
#define PosDEVICE_SHOPPER_DISPLAY_A             0x26
#define PosDEVICE_SHOPPER_DISPLAY_B             0x27
#define PosDEVICE_APA_DISPLAY_A                 0x2A
#define PosDEVICE_APA_DISPLAY_B                 0x2B
#define PosDEVICE_APA_DISPLAY_C                 0x2C
#define PosDEVICE_APA_DISPLAY_D                 0x2D
#define PosDEVICE_PRINTER_2                     0x30
#define PosDEVICE_PRINTER_4689_THERMAL          0x32
#define PosDEVICE_PRINTER_3                     0x34
#define PosDEVICE_PRINTER_4                     0x34
#define PosDEVICE_PRINTER_4610                  0x35
#define PosDEVICE_PRINTER_4689                  0x37
#define PosDEVICE_PRINTER_FISCAL_3              0x38
#define PosDEVICE_MSR_1_TRACK_A                 0x40
#define PosDEVICE_MSR_J_TRACK                   0x40
#define PosDEVICE_MSR_1_TRACK_B                 0x41
#define PosDEVICE_SCANNER_MOBILE                0x42
#define PosDEVICE_MSR_2_TRACK_A                 0x46
#define PosDEVICE_MSR_2_TRACK_B                 0x47
#define PosDEVICE_MSR_3_TRACK_A                 0x48
#define PosDEVICE_MSR_J_TRACK_A                 0x48
#define PosDEVICE_MSR_3_TRACK_B                 0x49
#define PosDEVICE_MSR_J_TRACK_B                 0x49
#define PosDEVICE_SCANNER_A                     0x4A
#define PosDEVICE_SCANNER_B                     0x4B
#define PosDEVICE_NVRAM_A                       0x50
#define PosDEVICE_NVRAM_B                       0x51
#define PosDEVICE_CASH_DRAWER_A                 0x54
#define PosDEVICE_TOUCH_SCREEN                  0x5C
#define PosDEVICE_TOUCH_SCREEN_B                0x5D
#define PosDEVICE_RS232_25A                     0x64
#define PosDEVICE_RS232_25B                     0x65
#define PosDEVICE_RS232_A                       0x66
#define PosDEVICE_RS232_B                       0x67
#define PosDEVICE_RS232_23A                     0x68
#define PosDEVICE_RS232_23B                     0x69
#define PosDEVICE_SCALE_A                       0x6A
#define PosDEVICE_SCALE                         0x6E

#define PosDEVICE_SYSTEM_ATTACHED_KBD           0x81
#define PosDEVICE_SYSTEM_ATTACHED_MSR           0x82

#define PosDEVICE_CASH_DRAWER_B                 0x83
#define PosDEVICE_ALARM                         0x84
#define PosDEVICE_NVRAM_LOCAL                   0x85
#define PosDEVICE_POWER_B                       0x86
#define PosDEVICE_POWER_LOCAL                   0x87

#define PosDEVICE_UKBD_SWITCH                   0xFD   // KBK
#define PosDEVICE_INTERNAL_SNF                  0xFE
#define PosDEVICE_INTERNAL_POSQ                 0xFF


/************************************************************/
/* Values for the TYPE field of ONLINE and OFFLINE messages */
/************************************************************/

#define PosTYPE_UNKNOWN                         0x01
#define PosTYPE_DISPLAY                         0x02
#define PosTYPE_PRINTER                         0x03
#define PosTYPE_SCANNER                         0x04
#define PosTYPE_MSR                             0x05
#define PosTYPE_CASH_DRAWER                     0x06
#define PosTYPE_ALARM                           0x07
#define PosTYPE_NVRAM                           0x08
#define PosTYPE_KEYBOARD                        0x09
#define PosTYPE_RS232                           0x0A
#define PosTYPE_SCALE                           0x0B
#define PosTYPE_POWER                           0x0C
#define PosTYPE_TOUCH_SCREEN                    0x0D

#define PosTYPE_INTERNAL_ORC                    0xFE
#define PosTYPE_INTERNAL_SNF                    0xFF


/***************************************************************/
/* Values for the SUBTYPE field of ONLINE and OFFLINE messages */
/***************************************************************/

#define PosSUBTYPE_NONE                         0x00


/**************************************************/
/* Resource values shared by multiple POS devices */
/**************************************************/

#define PosDISABLE                              0x00
#define PosENABLE                               0x01

#define PosOFF                                  0x00
#define PosON                                   0x01

#define PosLOWEST                               0x00
#define PosLOW                                  0x01
#define PosMEDIUM                               0x02
#define PosHIGH                                 0x03
#define PosHIGHEST                              0x04

#define PosTIMEOUT_INDEFINITE                   (-1)


#endif   /* _H_POS_DEVICE */
