/* @(#)02       1.3  src/include/pos/display.h, apicode, ptuxrolo, 35 5/16/01 18:30:53 */


/********************************************************************/
/*  <display.h> header file                                         */
/*                                                                  */
/*  Licensed Materials - Property of IBM                            */
/*                                                                  */
/*  IBM Point of Sale Subsystem                                     */
/*  73G0950 (C) Copyright IBM Corporation 1992, 2000                */
/*  All rights reserved                                             */
/*                                                                  */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication, or disclosure restricted                      */
/*  by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                  */
/********************************************************************/

#ifndef _H_POS_DISPLAY
#define _H_POS_DISPLAY 1

/********************************************************************/
/* Values for the SUBTYPE field of ONLINE and OFFLINE messages.     */
/********************************************************************/

#define PosDSP_SUBTYPE_2X20_LCD                 0x01  // Documented LCD DevID
#define PosDSP_SUBTYPE_2X20_LCD_I               0x03  // Observed LCD DevID
#define PosDSP_SUBTYPE_2X20_VFD                 0x06
#define PosDSP_SUBTYPE_2_SIDE_VFD               0x07
#define PosDSP_SUBTYPE_2X20_LCVFD               0xF6  // These are made up since they
#define PosDSP_SUBTYPE_2_SIDE_LCVFD             0xF7  // won't change the DevIDs...
#define PosDSP_SUBTYPE_APA_JAPAN                0x11
#define PosDSP_SUBTYPE_APA_KOREA                0x12
#define PosDSP_SUBTYPE_APA_TRAD_CHINESE         0x13
#define PosDSP_SUBTYPE_APA_SIMP_CHINESE         0x14


/*****************************/
/* PosDisplay resource names */
/*****************************/

#define PosNdisplayCursor               "displayCursor"
#define PosNdisplayCodePage             "displayCodePage"
#define PosNdisplayLightsOn             "displayLightsOn"
#define PosNpixelX                      "pixelX"
#define PosNpixelY                      "pixelY"
#define PosNcharSize                    "charSize"
#define PosNdisplayMode                 "displayMode"
#define PosNdisplayUpsideDown           "displayUpsideDown"



/*******************************/
/* PosDisplay resource classes */
/*******************************/

#define PosCDisplayCursor               "DisplayCursor"
#define PosCDisplayCodePage             "DisplayCodePage"
#define PosCDisplayLightsOn             "DisplayLightsOn"
#define PosCPixelX                      "PixelX"
#define PosCPixelY                      "PixelY"
#define PosCCharSize                    "CharSize"
#define PosCDisplayMode                 "DisplayMode"
#define PosCDisplayUpsideDown           "DisplayUpsideDown"

/*******************************/
/* APA display constants       */
/*******************************/

#define PosDSP_MODE_NORMAL              0x00
#define PosDSP_MODE_LOGO                0x01
#define PosDSP_MODE_APA                 0x02

#define PosDSP_MODE_SBCS                PosDSP_MODE_NORMAL

#define PosDSP_CHAR_2x20                0x00
#define PosDSP_CHAR_3x32                0x01


#define PosDSP_RIGHT_SIDE_UP            0x00
#define PosDSP_UPSIDE_DOWN              0x01

/*******************************************/
/* PosNdisplayCodePage resource constants  */
/*******************************************/

#define PosDSP_CP_US_EUROPE             0x00
#define PosDSP_CP_KATAKANA              0x01
#define PosDSP_CP_MULTILINGUAL_INTL     0x02      /* CP850 */
#define PosDSP_CP_HUNGARY               0x03      /* CP852 */
#define PosDSP_CP_CYRILLIC              0x04      /* CP855 */
#define PosDSP_CP_TURKEY                0x05      /* CP857 */
#define PosDSP_CP_ISRAEL                0x06      /* CP862 */
#define PosDSP_CP_CANADIAN_FRENCH       0x07      /* CP863 */
#define PosDSP_CP_ARABIC                0x08      /* CP864 */
#define PosDSP_CP_NORDIC                0x09      /* CP865 */
#define PosDSP_CP_CYRILLIC_RUSSIA       0x0A      /* CP866 */
#define PosDSP_CP_GREECE                0x0B      /* CP869 */
#define PosDSP_CP_JAPANESE              0x80      /* CP301 */
#define PosDSP_CP_KOREA                 0x90      /* CP951 */
#define PosDSP_CP_TRAD_CHINESE          0xA0      /* CP950 */
#define PosDSP_CP_SIMP_CHINESE          0xB0      /* CP1381 */

#endif   /* _H_POS_DISPLAY */
