/* @(#)04       1.4  src/include/pos/keyboard.h, apicode, ptuxrolo, 35 3/15/04 08:30:26 */

/********************************************************************/
/*  <keyboard.h> header file                                        */
/*                                                                  */
/*  Licensed Materials - Property of IBM                            */
/*                                                                  */
/*  IBM Point of Sale Subsystem                                     */
/*  73G0950 (C) Copyright IBM Corporation 1992, 2003                */
/*  All rights reserved                                             */
/*                                                                  */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication, or disclosure restricted                      */
/*  by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                  */
/********************************************************************/


#ifndef _H_POS_KEYBOARD
#define _H_POS_KEYBOARD 1

/********************************************************************/
/* Values for the SUBTYPE field of ONLINE and OFFLINE messages.     */
/********************************************************************/

#define PosKBD_SUBTYPE_CHECKOUT_2               1
#define PosKBD_SUBTYPE_MODIFIABLE_LAYOUT        2
#define PosKBD_SUBTYPE_ANPOS_2                  3
#define PosKBD_SUBTYPE_PC_POS                   4
#define PosKBD_SUBTYPE_KEYBOARD_V               5
#define PosKBD_SUBTYPE_PLU_KEYBOARD             6
#define PosKBD_SUBTYPE_KEYBOARD_VI              7
#define PosKBD_SUBTYPE_4685_K01                 8
#define PosKBD_SUBTYPE_SUREPOINT               10
#define PosKBD_SUBTYPE_KEYBOARD_E              11
#define PosKBD_SUBTYPE_4820_KEYPAD_NO_KEYS     12
#define PosKBD_SUBTYPE_4820_KEYPAD             13
#define PosKBD_SUBTYPE_CANPOS                  14
#define PosKBD_SUBTYPE_CRYSTAL                 15


/********************************************************************/
/* The PosNdoubleKey and PosCDoubleKey macros below designed to     */
/* allow you to create your own resource names.  For example,       */
/* PosNdoubleKey(01) will generate the string "PosNdoubleKey01".    */
/********************************************************************/


/******************************/
/* PosKeyboard resource names */
/******************************/

#define PosNkeyboardClick                       "keyboardClick"
#define PosNkeyLock                             "keyLock"
#define PosNkeyboardLightsOn                    "keyboardLightsOn"
#define PosNscanCodeSet                         "scanCodeSet"
#define PosNtoneFreq                            "toneFreq"
#define PosNtoneDuration                        "toneDuration"
#define PosNtoneVolume                          "toneVolume"
#define PosNdoubleKey01                         "doubleKey01"
#define PosNdoubleKey02                         "doubleKey02"
#define PosNdoubleKey03                         "doubleKey03"
#define PosNdoubleKey04                         "doubleKey04"
#define PosNdoubleKey05                         "doubleKey05"
#define PosNdoubleKey06                         "doubleKey06"
#define PosNdoubleKey07                         "doubleKey07"
#define PosNdoubleKey08                         "doubleKey08"
#define PosNdoubleKey09                         "doubleKey09"
#define PosNdoubleKey10                         "doubleKey10"
#define PosNdoubleKey11                         "doubleKey11"
#define PosNdoubleKey12                         "doubleKey12"
#define PosNdoubleKey13                         "doubleKey13"
#define PosNdoubleKey14                         "doubleKey14"
#define PosNdoubleKey15                         "doubleKey15"
#define PosNdoubleKey16                         "doubleKey16"
#define PosNdoubleKey17                         "doubleKey17"
#define PosNdoubleKey18                         "doubleKey18"
#define PosNdoubleKey19                         "doubleKey19"
#define PosNdoubleKey20                         "doubleKey20"
#define PosNdoubleKey21                         "doubleKey21"
#define PosNdoubleKey22                         "doubleKey22"
#define PosNdoubleKey23                         "doubleKey23"
#define PosNdoubleKey24                         "doubleKey24"
#define PosNdoubleKey25                         "doubleKey25"
#define PosNdoubleKey26                         "doubleKey26"
#define PosNdoubleKey27                         "doubleKey27"
#define PosNdoubleKey28                         "doubleKey28"
#define PosNdoubleKey29                         "doubleKey29"
#define PosNdoubleKey30                         "doubleKey30"
#define PosNdoubleKey31                         "doubleKey31"
#define PosNdoubleKey32                         "doubleKey32"
#define PosNdoubleKey33                         "doubleKey33"
#define PosNdoubleKey34                         "doubleKey34"
#define PosNdoubleKey35                         "doubleKey35"
#define PosNdoubleKey36                         "doubleKey36"
#define PosNdoubleKey37                         "doubleKey37"
#define PosNdoubleKey38                         "doubleKey38"
#define PosNdoubleKey39                         "doubleKey39"
#define PosNdoubleKey40                         "doubleKey40"
#define PosNdoubleKey41                         "doubleKey41"
#define PosNdoubleKey42                         "doubleKey42"
#define PosNdoubleKey43                         "doubleKey43"
#define PosNdoubleKey44                         "doubleKey44"
#define PosNdoubleKey45                         "doubleKey45"
#define PosNdoubleKey46                         "doubleKey46"
#define PosNdoubleKey47                         "doubleKey47"
#define PosNdoubleKey48                         "doubleKey48"
#define PosNdoubleKey49                         "doubleKey49"
#define PosNdoubleKey50                         "doubleKey50"
#define PosNdoubleKey51                         "doubleKey51"
#define PosNdoubleKey52                         "doubleKey52"
#define PosNdoubleKey53                         "doubleKey53"
#define PosNdoubleKey54                         "doubleKey54"
#define PosNdoubleKey55                         "doubleKey55"
#define PosNdoubleKey56                         "doubleKey56"
#define PosNdoubleKey57                         "doubleKey57"
#define PosNdoubleKey58                         "doubleKey58"
#define PosNdoubleKey59                         "doubleKey59"
#define PosNdoubleKey60                         "doubleKey60"
#define PosNfatFingerTimeOut                    "fatFingerTimeOut"
#define PosNnumpadLocation                      "numpadLocation"
#define PosNnumpadStyle                         "numpadStyle"
#define PosNnumpadZero                          "numpadZero"
#define PosNtypematicDelay                      "typematicDelay"
#define PosNtypematicFreq                       "typematicFreq"


/********************************/
/* PosKeyboard resource classes */
/********************************/

#define PosCKeyLock                             "KeyLock"
#define PosCKeyboardClick                       "KeyboardClick"
#define PosCKeyboardLightsOn                    "KeyboardLightsOn"
#define PosCScanCodeSet                         "ScanCodeSet"
#define PosCToneFreq                            "ToneFreq"
#define PosCToneDuration                        "ToneDuration"
#define PosCToneVolume                          "ToneVolume"
#define PosCDoubleKey01                         "DoubleKey01"
#define PosCDoubleKey02                         "DoubleKey02"
#define PosCDoubleKey03                         "DoubleKey03"
#define PosCDoubleKey04                         "DoubleKey04"
#define PosCDoubleKey05                         "DoubleKey05"
#define PosCDoubleKey06                         "DoubleKey06"
#define PosCDoubleKey07                         "DoubleKey07"
#define PosCDoubleKey08                         "DoubleKey08"
#define PosCDoubleKey09                         "DoubleKey09"
#define PosCDoubleKey10                         "DoubleKey10"
#define PosCDoubleKey11                         "DoubleKey11"
#define PosCDoubleKey12                         "DoubleKey12"
#define PosCDoubleKey13                         "DoubleKey13"
#define PosCDoubleKey14                         "DoubleKey14"
#define PosCDoubleKey15                         "DoubleKey15"
#define PosCDoubleKey16                         "DoubleKey16"
#define PosCDoubleKey17                         "DoubleKey17"
#define PosCDoubleKey18                         "DoubleKey18"
#define PosCDoubleKey19                         "DoubleKey19"
#define PosCDoubleKey20                         "DoubleKey20"
#define PosCDoubleKey21                         "DoubleKey21"
#define PosCDoubleKey22                         "DoubleKey22"
#define PosCDoubleKey23                         "DoubleKey23"
#define PosCDoubleKey24                         "DoubleKey24"
#define PosCDoubleKey25                         "DoubleKey25"
#define PosCDoubleKey26                         "DoubleKey26"
#define PosCDoubleKey27                         "DoubleKey27"
#define PosCDoubleKey28                         "DoubleKey28"
#define PosCDoubleKey29                         "DoubleKey29"
#define PosCDoubleKey30                         "DoubleKey30"
#define PosCDoubleKey31                         "DoubleKey31"
#define PosCDoubleKey32                         "DoubleKey32"
#define PosCDoubleKey33                         "DoubleKey33"
#define PosCDoubleKey34                         "DoubleKey34"
#define PosCDoubleKey35                         "DoubleKey35"
#define PosCDoubleKey36                         "DoubleKey36"
#define PosCDoubleKey37                         "DoubleKey37"
#define PosCDoubleKey38                         "DoubleKey38"
#define PosCDoubleKey39                         "DoubleKey39"
#define PosCDoubleKey40                         "DoubleKey40"
#define PosCDoubleKey41                         "DoubleKey41"
#define PosCDoubleKey42                         "DoubleKey42"
#define PosCDoubleKey43                         "DoubleKey43"
#define PosCDoubleKey44                         "DoubleKey44"
#define PosCDoubleKey45                         "DoubleKey45"
#define PosCDoubleKey46                         "DoubleKey46"
#define PosCDoubleKey47                         "DoubleKey47"
#define PosCDoubleKey48                         "DoubleKey48"
#define PosCDoubleKey49                         "DoubleKey49"
#define PosCDoubleKey50                         "DoubleKey50"
#define PosCDoubleKey51                         "DoubleKey51"
#define PosCDoubleKey52                         "DoubleKey52"
#define PosCDoubleKey53                         "DoubleKey53"
#define PosCDoubleKey54                         "DoubleKey54"
#define PosCDoubleKey55                         "DoubleKey55"
#define PosCDoubleKey56                         "DoubleKey56"
#define PosCDoubleKey57                         "DoubleKey57"
#define PosCDoubleKey58                         "DoubleKey58"
#define PosCDoubleKey59                         "DoubleKey59"
#define PosCDoubleKey60                         "DoubleKey60"
#define PosCFatFingerTimeOut                    "FatFingerTimeOut"
#define PosCNumpadLocation                      "NumpadLocation"
#define PosCNumpadStyle                         "NumpadStyle"
#define PosCNumpadZero                          "NumpadZero"
#define PosCTypematicDelay                      "TypematicDelay"
#define PosCTypematicFreq                       "TypematicFreq"


/******************************************************************/
/* NOTE: The PosNhotKeys, PosNnumLock, PosNscrLock, PosNtoneFreq, */
/* PosNtoneDuration, and PosNtoneVolume resources use values      */
/* defined in pos/pos.h                                           */
/******************************************************************/


/*******************************/
/* PosNkeyLock resource values */
/*******************************/

#define PosPOSITION_UNKNOWN                     0x00
#define PosPOSITION_MANAGER                     0x01
#define PosPOSITION_OPERATOR                    0x02
#define PosPOSITION_INACTIVE                    0x03
#define PosPOSITION_SYSTEM                      0x04
#define PosPOSITION_PC_MODE                     0x05
#define PosPOSITION_CHECK                       0x05
#define PosPOSITION_ACCOUNT                     0x06
#define PosPOSITION_1                           PosPOSITION_MANAGER
#define PosPOSITION_2                           PosPOSITION_OPERATOR


/****************************************/
/* PosNkeyboardLightsOn resource values */
/****************************************/

#define PosLIGHTS_OFF                           0x00
#define PosLIGHTS_WAIT                          0x01
#define PosLIGHTS_OFFLINE                       0x02
#define PosLIGHTS_MESSAGE_PENDING               0x04
#define PosLIGHTS_NO_LABEL                      0x08
#define PosLIGHTS_READY                         0x08


/*************************************/
/* PosNkeyboardClick resource values */
/*************************************/

#define PosSOFT                                 0x01
#define PosLOUD                                 0x02


/**************************************/
/* PosNnumpadLocation resource values */
/**************************************/

#define PosLOCATION_1                           0x01
#define PosLOCATION_2                           0x02
#define PosLOCATION_3                           0x03

/***********************************/
/* PosNnumpadStyle resource values */
/***********************************/

#define PosTOUCHTONE_POS                        0x00
#define PosCALCULATOR_POS                       0x01
#define PosTOUCHTONE_STANDARD                   0x02
#define PosCALCULATOR_STANDARD                  0x03


/**********************************/
/* PosNnumpadZero resource values */
/**********************************/

#define PosSINGLE_KEY                           0x01
#define PosDOUBLE_KEY                           0x02


/***********************************/
/* PosNscanCodeSet resource values */
/***********************************/

#define PosSIO                                  0x00
#define PosSYSTEM                               0x01


/***********************************/
/* ANPOS key scan code definitions */
/***********************************/

#define ANPOSKey077ScanCode                     0x6A
#define ANPOSKey078ScanCode                     0x6B
#define ANPOSKey082ScanCode                     0x6C
#define ANPOSKey087ScanCode                     0x6D
#define ANPOSKey088ScanCode                     0x6E
#define ANPOSKey090ScanCode                     0x6F
#define ANPOSKey094ScanCode                     0x77
#define ANPOSKey095ScanCode                     0x78
#define ANPOSKey100ScanCode                     0x7C
#define ANPOSKey105ScanCode                     0x7A
#define ANPOSKey106ScanCode                     0x7E
#define ANPOSKey107ScanCode                     0x5F
#define ANPOSKey108ScanCode                     0x71
#define ANPOSKey110ScanCode                     0x72
#define ANPOSKey111ScanCode                     0x63
#define ANPOSKey112ScanCode                     0x74
#define ANPOSKey113ScanCode                     0x75
#define ANPOSKey114ScanCode                     0x76


/*************************************/
/* ANPOS_2 key scan code definitions */
/*************************************/

#define ANPOS2Key077ScanCode                    0x6A
#define ANPOS2Key078ScanCode                    0x6B
#define ANPOS2Key082ScanCode                    0x6C
#define ANPOS2Key087ScanCode                    0x6D
#define ANPOS2Key088ScanCode                    0x6E
#define ANPOS2Key090ScanCode                    0x6F
#define ANPOS2Key095ScanCode                    0x78
#define ANPOS2Key099ScanCode                    0x77
#define ANPOS2Key100ScanCode                    0x7C
#define ANPOS2Key105ScanCode                    0x7A
#define ANPOS2Key106ScanCode                    0x7E
#define ANPOS2Key107ScanCode                    0x5F
#define ANPOS2Key108ScanCode                    0x71
#define ANPOS2Key124ScanCode                    0x63
#define ANPOS2Key125ScanCode                    0x74
#define ANPOS2Key126ScanCode                    0x75
#define ANPOS2Key127ScanCode                    0x76
#define ANPOS2Key128ScanCode                    0x59
#define ANPOS2Key135ScanCode                    0x72


/**********************************************/
/* POSM_KBD_STATUS_CHANGE definitions for mp1 */
/**********************************************/

#define PosKEY_LOCK                             0x0001


/****************************************/
/* POSM_KBD_WM_CHAR definitions for mp2 */
/****************************************/

#define PosKC_NONE                              0x0000 /* Not used */
#define PosKC_CHAR                              0x0001
#define PosKC_VIRTUALKEY                        0x0002 /* Not used */
#define PosKC_SCANCODE                          0x0004
#define PosKC_SHIFT                             0x0008
#define PosKC_CTRL                              0x0010
#define PosKC_ALT                               0x0020
#define PosKC_KEYUP                             0x0040
#define PosKC_PREVDOWN                          0x0080 /* Not used */
#define PosKC_LONEKEY                           0x0100 /* Not used */
#define PosKC_DEADKEY                           0x0200 /* Not used */
#define PosKC_COMPOSITE                         0x0400 /* Not used */
#define PosKC_INVALIDCOMP                       0x0800 /* Not used */
#define PosKC_FATFINGER                         0x8000

#endif   /* _H_POS_KEYBOARD */
