/* @(#)05       1.1  src/include/pos/msr.h, apicode, ptuxrolo, 35 1/13/00 18:45:09 */


/********************************************************************/
/*  <msr.h> header file                                             */
/*                                                                  */
/*  Licensed Materials - Property of IBM                            */
/*                                                                  */
/*  IBM Point of Sale Subsystem                                     */
/*  73G0950 (C) Copyright IBM Corporation 1992, 1997                */
/*  All rights reserved                                             */
/*                                                                  */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication, or disclosure restricted                      */
/*  by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                  */
/********************************************************************/

#ifndef _H_POS_MSR
#define _H_POS_MSR 1

/********************************************************************/
/* Values for the SUBTYPE field of ONLINE and OFFLINE messages.     */
/********************************************************************/

#define PosMSR_SUBTYPE_NONE       0
#define PosMSR_SUBTYPE_ENCODER    1


/*****************************/
/* PosMsr resource names     */
/*****************************/

#define PosNmsrEncodeTimeout    "msrEncodeTimeout"


/*******************************/
/* PosMsr resource classes */
/*******************************/

#define PosCMsrEncodeTimeout    "MsrEncodeTimeout"


/*****************************/
/* PosNtrack resource values */
/*****************************/

#define PosTRACK_ALL              0xFFFFFFFF
#define PosTRACK_1                0x00000001
#define PosTRACK_2                0x00000002
#define PosTRACK_3                0x00000004
#define PosTRACK_J                0x00000008


/************************************************************/
/* Constants used in the DFlags field of the MSR data block */
/************************************************************/

#define POS_MSR_TRK_ERROR         0x0001


/****************************************************************/
/* PosMsrDataHdr structure -- Scanner label data header         */
/****************************************************************/

typedef struct
  {
    unsigned long  Track;               /* Track Information */
    unsigned short Flags;               /* Flags             */
    unsigned short Length;              /* Data Length       */
  } PosMsrDataHdr;


#endif   /* _H_POS_MSR */
