/* @(#)00       1.10  src/include/pos/pos.h, apicode, ptuxrolo, 35 4/28/03 14:39:00 */

/********************************************************************/
/*  <pos.h> header file                                             */
/*                                                                  */
/*  Licensed Materials - Property of IBM                            */
/*                                                                  */
/*  IBM Point of Sale Subsystem                                     */
/*  73G0950 (C) Copyright IBM Corporation 1992, 2000                */
/*  All rights reserved                                             */
/*                                                                  */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication, or disclosure restricted                      */
/*  by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                  */
/*  Note: The symbol __cplusplus should not be defined by non-C++   */
/*        compilers.                                                */
/*                                                                  */
/********************************************************************/

#ifndef _H_POS_POS
#define _H_POS_POS  1


/********************************************************************/
/* Device Class names used on PosOpen                               */
/********************************************************************/

#define PosAlarm                              "PosAlarm"
#define PosDrawer                             "PosDrawer"
#define PosDisplay                            "PosDisplay"
#define PosKeyboard                           "PosKeyboard"
#define PosMsr                                "PosMsr"
#define PosNvram                              "PosNvram"
#define PosPower                              "PosPower"
#define PosPrinter                            "PosPrinter"
#define PosRs232                              "PosRs232"
#define PosScale                              "PosScale"
#define PosScanner                            "PosScanner"
#define PosTouch                              "PosTouch"
#define PosInternal                           "PosInternal"


/********************************************************************/
/* Request values used with PosIOCtl                                */
/********************************************************************/
/* Note: The values for each component use the same ranges as the   */
/*       error numbers.                                             */
/********************************************************************/

#define POS_TILL_OPEN_TILL                    (5400 + 1)
#define POS_ALARM_SILENCE_ALARM               (5400 + 2)
#define POS_ALARM_SOUND_ALARM                 (5400 + 3)

#define POS_DSP_CLEAR_SCREEN                  (4400 + 1)
#define POS_DSP_DEFINE_CHARACTERS             (4400 + 2)

#define POS_KBD_DISABLE_POS_FUNCTIONS         (4700 + 1)
#define POS_KBD_ENABLE_POS_FUNCTIONS          (4700 + 2)
#define POS_KBD_SILENCE_TONE                  (4700 + 4)
#define POS_KBD_SOUND_TONE                    (4700 + 5)
#define POS_KBD_SET_TYPEMATIC_OFF             (4700 + 6)
#define POS_KBD_SET_TYPEMATIC_ON              (4700 + 7)
#define POS_KBD_DISABLE_HOT_KEYS              (4700 + 8)
#define POS_KBD_ENABLE_HOT_KEYS               (4700 + 9)
#define POS_KBD_DISABLE_NUM_LOCK              (4700 + 10)
#define POS_KBD_ENABLE_NUM_LOCK               (4700 + 11)
#define POS_KBD_DISABLE_SCROLL_LOCK           (4700 + 12)
#define POS_KBD_ENABLE_SCROLL_LOCK            (4700 + 13)
#define POS_KBD_SET_NUM_LOCK_OFF              (4700 + 15)
#define POS_KBD_SET_NUM_LOCK_ON               (4700 + 16)
#define POS_KBD_SET_SCROLL_LOCK_OFF           (4700 + 17)
#define POS_KBD_SET_SCROLL_LOCK_ON            (4700 + 18)

#define POS_POWER_OFF                         (6400 + 1)
#define POS_POWER_ON                          (6400 + 2)
#define POS_POWER_SET_ALARM                   (6400 + 3)

#define POS_PRN_DISABLE_DI_PRINTING           (4900 + 1)
#define POS_PRN_ENABLE_DI_PRINTING            (4900 + 2)
#define POS_PRN_RESUME_PRINTING               (4900 + 3)
#define POS_PRN_RETRY_PRINTING                (4900 + 4)
#define POS_PRN_DISCARD_DATA                  (4900 + 5)
#define POS_PRN_DISABLE_FISCAL_PRINTING       (4900 + 6)
#define POS_PRN_ENABLE_FISCAL_PRINTING        (4900 + 7)
#define POS_PRN_RESET_PRINTER                 (4900 + 8)
#define POS_PRN_DEFINE_CHARACTERS             (4900 + 9)
#define POS_PRN_HOLD_PRINTING                 (4900 + 10)
#define POS_PRN_RELEASE_PRINTING              (4900 + 11)
#define POS_PRN_DISABLE_EXCLUSIVE_DI_PRINTING (4900 + 12)
#define POS_PRN_ENABLE_EXCLUSIVE_DI_PRINTING  (4900 + 13)
#define POS_PRN_SOUND_TONE                    (4900 + 14)
#define POS_PRN_SILENCE_TONE                  (4900 + 15)
#define POS_PRN_ENABLE_CASH_DRAWER            (4900 + 16)
#define POS_PRN_DISABLE_CASH_DRAWER           (4900 + 17)
#define POS_PRN_ERASE_EPROM_MEMORY            (4900 + 18)

#define POS_SCAN_DISCARD_DATA                 (5700 + 1)

#define POS_RS232_SEND_BREAK                  (5900 + 1)

#define POS_SCALE_ZERO_SCALE                  (6100 + 1)
#define POS_SCALE_CLEAR_SCREEN                (6100 + 2)

#define POS_TOUCH_SILENCE_TONE                (6700 + 1)
#define POS_TOUCH_SOUND_TONE                  (6700 + 2)

#define POS_SYS_ACQUIRE_DEVICE                ( 300 + 1)
#define POS_SYS_GET_VALUES                    ( 300 + 2)
#define POS_SYS_LOCK_DEVICE                   ( 300 + 3)
#define POS_SYS_RELEASE_DEVICE                ( 300 + 4)
#define POS_SYS_SET_VALUES                    ( 300 + 5)
#define POS_SYS_UNLOCK_DEVICE                 ( 300 + 6)


/********************************************************************/
/* Event values used on the input queue                             */
/********************************************************************/
/* The IBM Point of Sale Subsystem reserves a range of 256 numbers  */
/* (from 0x4200 to 0x42FF), most of which will be reserved for      */
/* future use.                                                      */
/********************************************************************/

#define POSM_MSG_BASE                         0x4200

#define POSM_KBD_STATUS_CHANGE                (POSM_MSG_BASE + 1)
#define POSM_KBD_WM_CHAR                      (POSM_MSG_BASE + 2)
#define POSM_MSR_DATA_AVAIL                   (POSM_MSG_BASE + 3)
#define POSM_PRN_CHASE_COMPLETE               (POSM_MSG_BASE + 4)
#define POSM_PRN_PRINTER_ERROR                (POSM_MSG_BASE + 5)
#define POSM_PRN_STATUS_CHANGE                (POSM_MSG_BASE + 6)
#define POSM_RS232_BREAK_DETECTED             (POSM_MSG_BASE + 7)
#define POSM_RS232_DATA_AVAIL                 (POSM_MSG_BASE + 8)
#define POSM_RS232_XMIT_ABORT                 (POSM_MSG_BASE + 9)
#define POSM_RS232_XMIT_COMPLETE              (POSM_MSG_BASE + 10)
#define POSM_SCAN_DATA_AVAIL                  (POSM_MSG_BASE + 11)
#define POSM_SYS_DEVICE_OFFLINE               (POSM_MSG_BASE + 12)
#define POSM_SYS_DEVICE_ONLINE                (POSM_MSG_BASE + 13)
#define POSM_TILL_CLOSED                      (POSM_MSG_BASE + 14)
#define POSM_TILL_OPENED                      (POSM_MSG_BASE + 15)
#define POSM_PRN_DATA_AVAIL                   (POSM_MSG_BASE + 16)
#define POSM_PRN_FISCAL_ERROR                 (POSM_MSG_BASE + 17)
#define POSM_PRN_FISCAL_STATUS                (POSM_MSG_BASE + 18)
#define POSM_SYS_DEVICE_RELEASED              (POSM_MSG_BASE + 19)
#define POSM_PRN_RAS_STATUS                   (POSM_MSG_BASE + 20)
#define POSM_PRN_RAS_ERROR                    (POSM_MSG_BASE + 21)
#define POSM_TOUCH_DATA                       (POSM_MSG_BASE + 22)
#define POSM_PRN_RAW_STATUS                   (POSM_MSG_BASE + 23)
#define POSM_MSR_WRITE_SUCCESS                (POSM_MSG_BASE + 24)
#define POSM_MSR_WRITE_FAILED                 (POSM_MSG_BASE + 25)
#define POSM_DSP_RAS_STATUS                   (POSM_MSG_BASE + 26)


/********************************************************************/
/* User defined types used in the POS calls                         */
/********************************************************************/
/*                                                                  */
/* size_t MUST be 32 bits long to successfully interface with the   */
/* DLL calls.  If ssize_t and off_t are already defined, they must  */
/* be defined the same way as here.                                 */
/*                                                                  */
/* The checks for __size_t and _SIZE_T and used to ensure that the  */
/* typedef for size_t isn't done multiple times, thus avoiding      */
/* an error.  ssize_t and off_t are not protected and are defined   */
/* the same on both systems.                                        */
/********************************************************************/

#if defined(__OS2__)

#ifndef __size_t                        /* Used by C Set/2 compiler */
#define __size_t
typedef unsigned int size_t;
#endif

#elif defined(_BORLANDC_)

#ifndef _SIZE_T                         /* Used by Borland C/C++ compilers */
#define _SIZE_T
typedef unsigned int size_t;
typedef int    ssize_t;
typedef long   off_t;
#endif

#elif defined(_WIN32)
#ifndef _SIZE_T_DEFINED                /* Used by Microsoft Visual C++ 32-bit */
#define _SIZE_T_DEFINED
typedef unsigned int size_t;
typedef int    ssize_t;
typedef long   off_t;
#endif

#elif defined(_WINDOWS)
#ifndef _SIZE_T_DEFINED                /* Used by Microsoft Visual C++ 1.x */
#define _SIZE_T_DEFINED
typedef unsigned int size_t;
typedef int    ssize_t;
typedef long   off_t;
#endif

#elif defined(__UNIX__) || defined(__unix__)

#include <unistd.h>
#ifndef _SIZE_T                         /* Used by IBM XL C++ compilers */
#define _SIZE_T
typedef unsigned long size_t;
typedef int    ssize_t;
typedef long   off_t;
#endif

#else
#error Unrecognized platform
#endif

#if defined(__OS2__)
  #include <os2.h>
  #ifndef FAR
    #define FAR
  #endif
  #if defined(__BORLANDC__)
    #define _OPTLINK __stdcall
    #define _SYSTEM  __syscall
  #else
    #define _OPTLINK _Optlink
    #define _SYSTEM  _System
  #endif
  #if defined(POSDLLAPI)
    #define POSAPI APIENTRY
  #endif
#elif defined(_WIN32) || defined(__WIN32__)
  #ifndef _X86_
    #define _X86_
  #endif
  #include <windef.h>
  #ifndef FAR
    #define FAR far
  #endif
  #define _OPTLINK __stdcall
  #define _SYSTEM
  #if defined(POSDLLAPI)
    #define POSAPI WINAPI
  #endif
#elif defined(_WINDOWS) || defined(_Windows)
  #include <windows.h>
  #ifndef FAR
    #define FAR _far
  #endif
  #ifndef PASCAL
    #define PASCAL _pascal
  #endif
  #define _OPTLINK FAR PASCAL
  #define _SYSTEM
  #if defined(POSDLLAPI)
    #define POSAPI FAR PASCAL
  #endif
#else
  #ifndef FAR
    #define FAR
  #endif
  #define _OPTLINK
  #define _SYSTEM
#endif
#if !defined(POSAPI)
  #define POSAPI _OPTLINK
#endif


/********************************************************************/
/* Structure Definitions                                            */
/********************************************************************/

  /*************************************/
  /* PosArg and PosArgPtr declarations */
  /*************************************/

  typedef struct
    {
      char FAR *name;
      long value;
    } PosArg, FAR *PosArgPtr;


  /*********************/
  /* POSQMSG structure */
  /*********************/

  typedef struct _POSQMSG
    {
      long           pid;             /* Owning Processing id */
      unsigned long  msg;             /* event message id     */
      unsigned long  mp1;             /* message parameter 1  */
      unsigned long  mp2;             /* message parameter 2  */
    } POSQMSG;

#define EVENT_MESSAGE_SIZE              sizeof(POSQMSG)

  /*************************************/
  /* PosVPD and PosVPDPtr declarations */
  /* (VPD = Vital Product Data)        */
  /*************************************/

  typedef struct
    {
      char MachineType[7];
      char SerialNumber[7];
      char BIOSLevel[5];
      char reserved[5];
    } PosVPD, FAR *PosVPDPtr;


/********************************************************************/
/* Helper macros                                                    */
/********************************************************************/

#define PosSetArg(arg, n, d) \
  ((arg).name = (n), (arg).value = (long)(d))

#define PosNumber(arr) \
  ((unsigned int) (sizeof(arr) / sizeof(arr[0])))

#define PosSetValues(device, args, nargs) \
  PosIOCtl(device, POS_SYS_SET_VALUES, args, nargs)

#define PosGetValues(device, args, nargs) \
  PosIOCtl(device, POS_SYS_GET_VALUES, args, nargs)

                             
/********************************************************************/
/* Interface calls into the POS library (C/C++ only)                */
/********************************************************************/

/*************************************************************/
/* The following prevents C++ compilers from using type-safe */
/* linkage and thus 'mangling' the names of the functions    */
/* below.                                                    */
/*************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

int     POSAPI PosClose(int devdes);

int     POSAPI PosErrno(void);

int     POSAPI PosInitialize(const char FAR *applname, const char FAR *file,
                               int FAR *argc, char FAR * FAR *argv,
                               PosArgPtr args, int nargs);

int     POSAPI PosIOCtl(int devdes, int request, PosArgPtr args, int nargs);

int     POSAPI PosOpen(const char FAR *devname, const char FAR *devclass,
                         PosArgPtr args, int nargs);

ssize_t POSAPI PosRead(int devdes, void FAR *buf, size_t nbyte);

int     POSAPI PosTerm(void);

int     POSAPI PosVersion(int FAR *version, int FAR *release,
                            int FAR *modification);

ssize_t POSAPI PosWrite(int devdes, const void FAR *buf, size_t nbyte);


#ifdef __cplusplus
  }                             /* END extern "C" */
#endif


#endif   /* _H_POS_POS */

