/* @(#)09       1.14.1.5  src/include/pos/printer.h, apicode, ptuxrolo, 35 4/28/03 14:40:09 */


/********************************************************************/
/*  <printer.h> header file                                         */
/*                                                                  */
/*  Licensed Materials - Property of IBM                            */
/*                                                                  */
/*  IBM Point of Sale Subsystem                                     */
/*  73G0950 (C) Copyright IBM Corporation 1992, 1999                */
/*  All rights reserved                                             */
/*                                                                  */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication, or disclosure restricted                      */
/*  by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                  */
/********************************************************************/

#ifndef _H_POS_PRINTER
#define _H_POS_PRINTER 1

        
/********************************************************************/
/* Values for the SUBTYPE field of ONLINE and OFFLINE messages.     */
/********************************************************************/

#define PosPRN_SUBTYPE_4689_1           0x01
#define PosPRN_SUBTYPE_4689_2           0x02
#define PosPRN_SUBTYPE_M4A              0x03
#define PosPRN_SUBTYPE_4689_301         0x04

#define PosPRN_SUBTYPE_4610_TI1_TI2       0x00
#define PosPRN_SUBTYPE_4610_TI3_TI4       0x01
#define PosPRN_SUBTYPE_4610_TI5           0x02
#define PosPRN_SUBTYPE_4610_SST           0x03
#define PosPRN_SUBTYPE_4610_TI3_TI4_8MEG  0x04
#define PosPRN_SUBTYPE_4610_SST_8MEG      0x05
#define PosPRN_SUBTYPE_MACARENA           0x06
#define PosPRN_SUBTYPE_4610_SST_2MEG      0x07
#define PosPRN_SUBTYPE_4610_TI8           0x08




/*****************************/
/* PosPrinter resource names */
/*****************************/

#define PosNDIWidth                     "diWidth"
#define PosNfeedDirection               "feedDirection"
#define PosNfiscalCountry               "fiscalCountry"
#define PosNfiscalNotify                "fiscalNotify"
#define PosNfiscalPLDStatus             "fiscalPLDStatus"
#define PosNfiscalVersion               "fiscalVersion"
#define PosNheadParkedPosition          "headParkedPosition"
#define PosNinterleaved                 "interleaved"
#define PosNlineFeedCR                  "lineFeedCR"
#define PosNlineFeedDI                  "lineFeedDI"
#define PosNlineFeedSJ                  "lineFeedSJ"
#define PosNprintMode                   "printMode"
#define PosNprintStation                "printStation"
#define PosNprintStatus                 "printStatus"
#define PosNprintStatus2                "printStatus2"
#define PosNrawPrintStatus              "rawPrintStatus"
#define PosNresumeString                "resumeString"
#define PosNretryString                 "retryString"
#define PosNprintFeatures               "printFeatures"
#define PosNdiOrientation               "diOrientation"
#define PosNleftMarginCR                "leftMarginCR"
#define PosNprintAlignment              "printAlignment"
#define PosNprintColorMode              "printColorMode"
#define PosNprintQualityMode            "printQualityMode"
#define PosNprintUpsideDown             "printUpsideDown"
#define PosNprintTabStops               "printTabStops"
#define PosNCRWidth                     "crWidth"
#define PosNprintToneFrequency          "printToneFrequency"
#define PosNprintToneVolume             "printToneVolume"
#define PosNprintToneDuration           "printToneDuration"
#define PosNprintToneOctave             "printToneOctave"
#define PosNprintToneNote               "printToneNote"
#define PosNprintCRCharSet1             "printCRCharSet1"
#define PosNprintCRCharSet2             "printCRCharSet2"
#define PosNprintCRCharSet3             "printCRCharSet3"
#define PosNprintCRCharSet4             "printCRCharSet4"
#define PosNprintDICharSet1             "printDICharSet1"
#define PosNprintDICharSet2             "printDICharSet2"
#define PosNprintCDAttached             "printCDAttached"
#define PosNprintCDPulseWidth           "printCDPulseWidth"
#define PosNprintCDStatusLevel          "printCDStatusLevel"
#define PosNrecordLength                "recordLength"
#define PosNmaximumRecords              "maximumRecords"
#define PosNmemoryAvailable             "memoryAvailable"


/*******************************/
/* PosPrinter resource classes */
/*******************************/

#define PosCDIWidth                     "DiWidth"
#define PosCFeedDirection               "FeedDirection"
#define PosCFiscalCountry               "FiscalCountry"
#define PosCFiscalNotify                "FiscalNotify"
#define PosCFiscalPLDStatus             "FiscalPLDStatus"
#define PosCFiscalVersion               "FiscalVersion"
#define PosCHeadParkedPosition          "HeadParkedPosition"
#define PosCInterleaved                 "Interleaved"
#define PosCLineFeedCR                  "LineFeedCR"
#define PosCLineFeedDI                  "LineFeedDI"
#define PosCLineFeedSJ                  "LineFeedSJ"
#define PosCPrintMode                   "PrintMode"
#define PosCPrintStation                "PrintStation"
#define PosCPrintStatus                 "PrintStatus"
#define PosCPrintStatus2                "PrintStatus2"
#define PosCRawPrintStatus              "RawPrintStatus"
#define PosCResumeString                "ResumeString"
#define PosCRetryString                 "RetryString"
#define PosCPrintFeatures               "PrintFeatures"
#define PosCDiOrientation               "DiOrientation"
#define PosCLeftMarginCR                "LeftMarginCR"
#define PosCPrintAlignment              "PrintAlignment"
#define PosCPrintColorMode              "PrintColorMode"
#define PosCPrintQualityMode            "PrintQualityMode"
#define PosCPrintUpsideDown             "PrintUpsideDown"
#define PosCPrintTabStops               "PrintTabStops"
#define PosCCRWidth                     "CrWidth"
#define PosCPrintToneFrequency          "PrintToneFrequency"
#define PosCPrintToneVolume             "PrintToneVolume"
#define PosCPrintToneDuration           "PrintToneDuration"
#define PosCPrintToneOctave             "PrintToneOctave"
#define PosCPrintToneNote               "PrintToneNote"
#define PosCPrintCRCharSet1             "printCRCharSet1"
#define PosCPrintCRCharSet2             "printCRCharSet2"
#define PosCPrintCRCharSet3             "printCRCharSet3"
#define PosCPrintCRCharSet4             "printCRCharSet4"
#define PosCPrintDICharSet1             "printDICharSet1"
#define PosCPrintDICharSet2             "printDICharSet2"
#define PosCPrintCDAttached             "printCDAttached"
#define PosCPrintCDPulseWidth           "printCDPulseWidth"
#define PosCPrintCDStatusLevel          "printCDStatusLevel"
#define PosCRecordLength                "recordLength"
#define PosCMaximumRecords              "maximumRecords"
#define PosCMemoryAvailable             "memoryAvailable"

/********************************************/
/* PosNprintXXCharSet# resource flags       */
/********************************************/

#define PosPRINT_PROPORTIONAL			 0x00
#define PosPRINT_PARTIAL				 0x01
#define PosPRINT_FIXEDFONT				 0x02
#define PosPRINT_NONE					 0x03

/***************************************/
/* PosNcrWidth resource flags  */
/***************************************/

#define  PosCR_WIDE                      0x00
#define  PosCR_NARROW                    0x01


/***************************************/
/* PosNprintToneOctave resource flags  */
/***************************************/

#define PosPRINT_OCTAVE1                 0x00
#define PosPRINT_OCTAVE2                 0x01
#define PosPRINT_OCTAVE3                 0x02
#define PosPRINT_OCTAVE4                 0x03
    
/***************************************/
/* PosNprintToneNote resource flags    */
/***************************************/

#define PosPRINT_TONE_C                  0x00
#define PosPRINT_TONE_C_SHARP            0x01
#define PosPRINT_TONE_D                  0x02
#define PosPRINT_TONE_D_SHARP            0x03
#define PosPRINT_TONE_E                  0x04
#define PosPRINT_TONE_F                  0x05
#define PosPRINT_TONE_F_SHARP            0x06
#define PosPRINT_TONE_G                  0x07
#define PosPRINT_TONE_G_SHARP            0x08
#define PosPRINT_TONE_A                  0x09
#define PosPRINT_TONE_A_SHARP            0x0A
#define PosPRINT_TONE_B                  0x0B


/*****************************************/
/* PosNprintToneFrequency resource flags */
/*****************************************/

#define PosPRINT_TONE_MIN_FREQ           261
#define PosPRINT_TONE_MED_FREQ           2093
#define PosPRINT_TONE_MAX_FREQ           3953


/***************************************/
/* PosNprintToneVolume resource flags  */
/***************************************/

#define PosPRINT_TONE_SOFT               0x00
#define PosPRINT_TONE_LOUD               0x01

/***************************************/
/* PosNprintUpsideDown resource flags  */
/***************************************/

#define PosPRINT_RIGHT_SIDE_UP           0x00
#define PosPRINT_UPSIDE_DOWN             0x01

/****************************************/
/* PosNprintQualityMode resource flags  */
/****************************************/

#define PosHIGH_QUALITY_OFF              0x00
#define PosHIGH_QUALITY_ON               0x01

/*********************************/
/* PosNcolorMode resource flags */
/*********************************/

#define PosPAPER_NORMAL                  0x00
#define PosPAPER_TWO_COLOR               0x01

/*******************************/
/* PosNdiWidth resource values */
/*******************************/

#define PosDI_WIDE                      0x0
#define PosDI_NARROW                    0x1


/*************************************/
/* PosNfeedDirection resource values */
/*************************************/

#define PosFEED_FORWARD                 0x0
#define PosFEED_REVERSE                 0x1


/************************************/
/* PosNfiscalNotify resource values */
/************************************/

#define PosFISCAL_NOTIFY_OFF            0x0
#define PosFISCAL_NOTIFY_ON             0x1


/***************************************/
/* PosNfiscalPLDStatus resource values */
/***************************************/

#define PosFISCAL_PLD_FALSE             0x0
#define PosFISCAL_PLD_TRUE              0x1


/*******************************************/
/* PosNheadParkedPosition resource values  */
/* (specifies the desired parked position) */
/*******************************************/

#define PosHOME_CENTER                  0x0
#define PosHOME_LEFT                    0x1


/***********************************/
/* PosNinterleaved resource values */
/***********************************/

#define PosINTERLEAVED_FALSE            0x0
#define PosINTERLEAVED_TRUE             0x1


/*******************************************************************/
/*  PosNlineFeedCR, PosNlineFeedSJ, PosNlineFeedDI resource values */
/*******************************************************************/

#define PosLPI_6                        4236
#define PosLPI_8                        3177


/*********************************/
/* PosNprintMode resource values */
/*********************************/

#ifndef PosMODE_DIRECT
#define PosMODE_DIRECT                  0x00
#endif
#define PosMODE_NORMAL                  0x01
#define PosMODE_LOGO                    0x02
#define PosMODE_FISCAL                  0x04
#define PosMODE_LOAD_MESSAGE            0x08
#define PosMODE_LOAD_LOGO               0x10


/************************************/
/* PosNprintStation resource values */
/************************************/

#define PosPRINT_STATION_CR             0x0001
#define PosPRINT_STATION_SJ             0x0002
#define PosPRINT_STATION_DI             0x0004

/*************************************/
/* PosNdiOrientation resource values */
/*************************************/

#define PosPRINT_PORTRAIT               0x0000
#define PosPRINT_LANDSCAPE              0x0001

/************************************/
/* PosNleftMarginCR resource values */
/************************************/

#define PosLEFT_MARGIN_NONE             0x0000
#define PosLEFT_MARGIN_MODEL4           0x80000000

/**************************************/
/* PosNprintAlignment resource values */
/**************************************/

#define PosPRINT_ALIGN_LEFT             0x0000
#define PosPRINT_ALIGN_CENTER           0x0001
#define PosPRINT_ALIGN_RIGHT            0x0002

/**********************************/
/* PosNprintStatus resource flags */
/**********************************/

#define PosSTATUS_COVER_OPEN            0x0001
#define PosSTATUS_TRANSPORT_ERROR       0x0002
#define PosSTATUS_SJ_PAPER_ERROR        0x0004
#define PosSTATUS_DOCUMENT_AT_FRONT     0x0008
#define PosSTATUS_DOCUMENT_AT_TOP       0x0010
#define PosSTATUS_DOCUMENT_READY        0x0020
#define PosSTATUS_HEAD_PARKED           0x0040
#define PosSTATUS_INSERTED_FORWARD      0x0080
#define PosSTATUS_ERROR_PENDING         0x0100
#define PosSTATUS_DI_FRONT_LOAD_ERROR   0x0200
#define PosSTATUS_DI_TOP_LOAD_ERROR     0x0400
#define PosSTATUS_DATA_AVAIL            0x0800
#define PosSTATUS_PRINTER_ONLINE        0x1000
#define PosSTATUS_MICR_INSTALLED        0x2000
#define PosSTATUS_CR_PAPER_LOW          0x4000
#define PosSTATUS_SJ_PAPER_LOW          0x8000


/***********************************/
/* PosNprintStatus2 resource flags */
/***********************************/

#define PosSTATUS2_PAPER_OUT            0x0001
#define PosSTATUS2_OVERHEAT             0x0002
#define PosSTATUS2_TEST_MODE            0x0004
#define PosSTATUS2_CUTTER_ERROR         0x0008
#define PosSTATUS2_CR_PRINT_HEAD_OPEN   0x0010
#define PosSTATUS2_SJ_PRINT_HEAD_OPEN   0x0020
#define PosSTATUS2_CD_OPEN              0x0040
#define PosSTATUS2_CR_STATION           0x1000
#define PosSTATUS2_DI_STATION           0x2000
#define PosSTATUS2_SJ_STATION           0x4000
#define PosSTATUS2_BUFFER_HELD          0x8000


/************************************/
/* PosNprintFeatures resource flags */
/************************************/

#define PosFEATURE_MICR_INSTALLED       0x0001
#define PosFEATURE_FLIPPER_INSTALLED    0x0002
#define PosFEATURE_58MM_PAPER           0x0004
#define PosFEATURE_TI8_PRN              0x0008
#define PosFEATURE_TI8_PRN_TI4_MODE     0x0010

/********************************************/
/* PosNprintCDAttached       resource flags */                                               
/********************************************/
#define PosCD_ATTACHED                  0x0001
#define PosCD_NOT_ATTACHED              0x0000
                                               
/********************************************/
/* PosNprintCDPulseWidth     resource flags */
/********************************************/
#define PosCD_PULSE_WIDTH               0x0028

/********************************************/
/* PosNprintCDStatusPolarity resource flags */
/********************************************/
#define PosCD_NEGATIVE                  0x0001
#define PosCD_POSITIVE                  0x0002

#define PosPRINTER_MP1(mp1) ((mp1) << 16)

/********************************/
/* POSM_PRN_STATUS_CHANGE flags */
/********************************/

#define PosCHANGE_DOCUMENT_AT_TOP       0x0001
#define PosCHANGE_DOCUMENT_AT_FRONT     0x0002
#define PosCHANGE_DOCUMENT_REGISTER     0x0004
#define PosCHANGE_COVER                 0x0008
#define PosCHANGE_CR_PAPER_LOW          0x0010
#define PosCHANGE_CR_PAPER_OUT          0x0011
#define PosCHANGE_CR_OVERHEAT           0x0012
#define PosCHANGE_CR_PRINT_HEAD         0x0013
#define PosCHANGE_SJ_PAPER_LOW          0x0020
#define PosCHANGE_SJ_PAPER_OUT          0x0021
#define PosCHANGE_SJ_OVERHEAT           0x0022
#define PosCHANGE_SJ_PRINT_HEAD         0x0023
#define PosCHANGE_CD_OPEN               0x0024
#define PosCHANGE_CD_CLOSED             0x0025
#define PosCHANGE_TEST_MODE             0x0040
#define PosCHANGE_SJ_PAPER              0x0080


/********************************/
/* POSM_PRN_PRINTER_ERROR flags */
/********************************/

#define PosERROR_COVER_OPEN             0x0001
#define PosERROR_TRANSPORT_ERROR        0x0002
#define PosERROR_CR_PRINT_HEAD_OPEN     0x0003
#define PosERROR_SJ_PAPER_ERROR         0x0004
#define PosERROR_SJ_PRINT_HEAD_OPEN     0x0005
#define PosERROR_DOCUMENT_INSERTED      0x0008
#define PosERROR_DOCUMENT_NOT_INSERTED  0x0010
#define PosERROR_DOCUMENT_NOT_READY     0x0020
#define PosERROR_DOCUMENT_NOT_EJECTED   0x0040
#define PosERROR_MICR_ERROR             0x0080
#define PosERROR_CR_PAPER_ERROR         0x0100
#define PosERROR_EEPROM_LOAD_ERROR      0x0200
#define PosERROR_EEPROM_FULL            0x0400
#define PosERROR_COMMUNICATION_ERROR    0x1000
#define PosERROR_DI_FEED_ERROR          0x2000
#define PosERROR_STARTUP_ERROR          0x4000
#define PosERROR_UNRECOVERABLE_ERROR    0x4001
#define PosERROR_COMMAND_REJECTED       0x8000


/*********************************/
/* POSM_PRN_CHASE_COMPLETE flags */
/*********************************/

#define PosCHASE_FROM_CR                0x0001
#define PosCHASE_FROM_SJ                0x0002
#define PosCHASE_FROM_DI                0x0004


/*********************************/
/* POSM_PRN_DATA_AVAIL flags */
/*********************************/

#define PosPRINT_DATA_AVAIL_FISCAL      0x0001
#define PosPRINT_DATA_AVAIL_MICR        0x0002
#define PosPRINT_DATA_AVAIL_FLASH       0x0003


#endif   /* _H_POS_PRINTER */
