/* @(#)08       1.1  src/include/pos/rs232c.h, apicode, ptuxrolo, 35 1/13/00 18:45:20 */

/********************************************************************/
/*  <rs232c.h> header file                                          */
/*                                                                  */
/*  Licensed Materials - Property of IBM                            */
/*                                                                  */
/*  IBM Point of Sale Subsystem                                     */
/*  73G0950 (C) Copyright IBM Corporation 1992, 1995                */
/*  All rights reserved                                             */
/*                                                                  */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication, or disclosure restricted                      */
/*  by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                  */
/********************************************************************/

#ifndef _H_POS_RS232C
#define _H_POS_RS232C 1

/****************************************************************/
/* Values for the SUBTYPE field of ONLINE and OFFLINE messages. */
/****************************************************************/

#define PosRS232_SUBTYPE_USB_OEM     1  /* USB "pseudo" RS232C  */

/***************************/
/* PosRs232 resource names */
/***************************/

#define PosNrs232Status                 "rs232Status"
#define PosNlineMode                    "lineMode"
#define PosNbaudRate                    "baudRate"
#define PosNstopBits                    "stopBits"
#define PosNparity                      "parity"
#define PosNdataBits                    "dataBits"
#define PosNtimeoutChar                 "timeoutChar"


/*****************************/
/* PosRs232 resource classes */
/*****************************/

#define PosCRs232Status                 "Rs232Status"
#define PosCLineMode                    "LineMode"
#define PosCBaudRate                    "BaudRate"
#define PosCStopBits                    "StopBits"
#define PosCParity                      "Parity"
#define PosCDataBits                    "DataBits"
#define PosCTimeoutChar                 "TimeoutChar"


/********************************/
/* PosNbaudRate resource values */
/********************************/

#define PosBAUD_RATE_110                110
#define PosBAUD_RATE_300                300
#define PosBAUD_RATE_1200               1200
#define PosBAUD_RATE_2400               2400
#define PosBAUD_RATE_4800               4800
#define PosBAUD_RATE_9600               9600


/********************************/
/* PosNstopBits resource values */
/********************************/

#define PosSTOP_BITS_1                  10
#define PosSTOP_BITS_1_5                15
#define PosSTOP_BITS_2                  20


/******************************/
/* PosNparity resource values */
/******************************/

#define PosPARITY_NONE                  0
#define PosPARITY_ODD                   1
#define PosPARITY_EVEN                  2


/********************************/
/* PosNdataBits resource values */
/********************************/

#define PosDATA_BITS_5                  5
#define PosDATA_BITS_6                  6
#define PosDATA_BITS_7                  7
#define PosDATA_BITS_8                  8


/****************************************************/
/* PosNrs232Status and PosNlineMode resource values */
/****************************************************/

#define PosLOCAL_READY_ACTIVE           0x0001
#define PosLOCAL_OK_TO_SEND_ACTIVE      0x0002
#define PosREMOTE_READY_ACTIVE          0x0004
#define PosREMOTE_OK_TO_SEND_ACTIVE     0x0008
#define PosXMIT_BUF_EMPTY               0x0010
#define PosRECV_ENABLE                  0x0020
#define PosDTR_NOT_REQUIRED_FOR_XMIT    0x0040


/*****************************/
/* Receive data error values */
/*****************************/

#define POS_RS232_PARITY_ERROR          0x0001
#define POS_RS232_OVERRUN_ERROR         0x0002
#define POS_RS232_FRAMING_ERROR         0x0004


#endif   /* _H_POS_RS232C */
