/* @(#)11       1.1  src/include/pos/scale.h, apicode, ptuxrolo, 35 1/13/00 18:45:34 */

/********************************************************************/
/*  <scale.h> header file                                           */
/*                                                                  */
/*  Licensed Materials - Property of IBM                            */
/*                                                                  */
/*  IBM Point of Sale Subsystem                                     */
/*  73G0950 (C) Copyright IBM Corporation 1992, 1995                */
/*  All rights reserved                                             */
/*                                                                  */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication, or disclosure restricted                      */
/*  by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                  */
/********************************************************************/

#ifndef _H_POS_SCALE
#define _H_POS_SCALE 1

/****************************************************************/
/* Values for the SUBTYPE field of ONLINE and OFFLINE messages. */
/****************************************************************/

#define PosSCALE_SUBTYPE_4687           1
#define PosSCALE_SUBTYPE_4696           2
#define PosSCALE_SUBTYPE_4698           2
#define PosSCALE_SUBTYPE_USB_OEM        3


/*****************************/
/* PosScale resource names   */
/*****************************/

#define PosNdisplayRequired             "displayRequired"
#define PosNoperMode                    "operMode"
#define PosNvibrationFilter             "vibrationFilter"
#define PosNweightMode                  "weightMode"
#define PosNzeroIndState                "zeroIndState"
#define PosNzeroRetState                "zeroRetState"
#define PosNnumWeightDigits             "numWeightDigits"


/****************************/
/* Scale resource classes   */
/****************************/

#define PosCDisplayRequired             "DisplayRequired"
#define PosCOperMode                    "OperMode"
#define PosCVibrationFilter             "VibrationFilter"
#define PosCWeightMode                  "WeightMode"
#define PosCZeroIndState                "ZeroIndState"
#define PosCZeroRetState                "ZeroRetState"
#define PosCNumWeightDigits             "NumWeightDigits"



/****************************************************************/
/* Constants used in the Flags field of the scale data header   */
/****************************************************************/

#define POS_SCALE_IN_MOTION             0x0001
#define POS_SCALE_UNDER_ZERO            0x0002
#define POS_SCALE_OVER_CAPACITY         0x0004
#define POS_SCALE_REQUIRES_ZEROING      0x0008
#define POS_SCALE_NOT_READY             0x0010
#define POS_SCALE_DUPLICATE_WEIGHT      0x0020
#define POS_SCALE_HW_ERROR              0x0040
#define POS_SCALE_FIVE_DIGIT_WEIGHT     0x0080


/****************************************************************/
/* PosScaleData structure -- Scale data                         */
/****************************************************************/

typedef struct
  {
    unsigned short WtType;              /* Weight Type   */
    unsigned short Flags;               /* Flags         */
    long           WeightValue;         /* Weight Value  */
  } PosScaleData;


/**************************************************/
/* Constants used only by Scales                  */
/**************************************************/

#define PosENGLISH                      0x00
#define PosMETRIC                       0x01

#define PosUSCANADA                     0x00
#define PosUK                           0x01

#define PosFOUR_WEIGHT_DIGITS           0x00
#define PosFIVE_WEIGHT_DIGITS           0x01


#endif   /* _H_POS_SCALE */
