/* @(#)07       1.1  src/include/pos/scanner.h, apicode, ptuxrolo, 35 1/13/00 18:45:17 */

/********************************************************************/
/*  <scanner.h> header file                                         */
/*                                                                  */
/*  Licensed Materials - Property of IBM                            */
/*                                                                  */
/*  IBM Point of Sale Subsystem                                     */
/*  73G0950 (C) Copyright IBM Corporation 1992, 1995                */
/*  All rights reserved                                             */
/*                                                                  */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication, or disclosure restricted                      */
/*  by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                  */
/********************************************************************/

#ifndef _H_POS_SCANNER
#define _H_POS_SCANNER 1

/****************************************************************/
/* Values for the SUBTYPE field of ONLINE and OFFLINE messages. */
/****************************************************************/

                                     /* Portable (Mobile) Scanners */
#define PosSCAN_SUBTYPE_4612            1  /* 4612 SurePoint Mobile*/

                                     /* Hand-held Bar Code Readers */
#define PosSCAN_SUBTYPE_HHBCR_1         1            /* Model 1    */
#define PosSCAN_SUBTYPE_HHBCR_2         2            /* Model 2    */
#define PosSCAN_SUBTYPE_1520_A02        3            /* 1520-A02   */

                                     /* Flatbed Scanners */
#define PosSCAN_SUBTYPE_4687            1     /* 4687 Models 1 & 2 */
#define PosSCAN_SUBTYPE_4686_1_2        2     /* 4686 Models 1 & 2 */
#define PosSCAN_SUBTYPE_4686_3_4        3     /* 4686 Models 3 & 4 */
#define PosSCAN_SUBTYPE_4696            4     /* 4696              */
#define PosSCAN_SUBTYPE_4697            5     /* 4697              */
#define PosSCAN_SUBTYPE_4698            6     /* 4698              */

#define PosSCAN_SUBTYPE_USB_OEM         7     /* USB               */


/*****************************/
/* PosScanner resource names */
/*****************************/

#define PosNbarCodes1                   "barCodes1"
#define PosNbarCodes2                   "barCodes2"
#define PosNbarCodes3                   "barCodes3"
#define PosNbarCodes4                   "barCodes4"
#define PosNbarCodeProgramming          "barCodeProgramming"
#define PosNbeepFreq                    "beepFreq"
#define PosNbeepLength                  "beepLength"
#define PosNbeepState                   "beepState"
#define PosNbeepVolume                  "beepVolume"
#define PosNblinkLength                 "blinkLength"
#define PosNblock1Type                  "block1Type"
#define PosNblock2Type                  "block2Type"
#define PosNblock3Type                  "block3Type"
#define PosNblockReadMode               "blockReadMode"
#define PosNbVolSwitchState             "bVolSwitchState"
#define PosNcheckModulo                 "checkModulo"
#define PosNcode128ScansPerRead         "code128ScansPerRead"
#define PosNcode39ScansPerRead          "code39ScansPerRead"
#define PosNdReadTimeout                "dReadTimeout"
#define PosNdecodeAlgorithm             "decodeAlgorithm"
#define PosNdTouchMode                  "dTouchMode"
#define PosNiTFLength1                  "iTFLength1"
#define PosNiTFLength2                  "iTFLength2"
#define PosNiTFLengthType               "iTFLengthType"
#define PosNiTFScansPerRead             "iTFScansPerRead"
#define PosNjANTwoLabelDecode           "jANTwoLabelDecode"
#define PosNlabelsQueued                "labelsQueued"
#define PosNlaserTimeout                "laserTimeout"
#define PosNmotorTimeout                "motorTimeout"
#define PosNlaserSwitchState            "laserSwitchState"
#define PosNqueueAllLabels              "queueAllLabels"
#define PosNscansPerRead                "scansPerRead"
#define PosNeAN13ScansPerRead           "eAN13ScansPerRead"
#define PosNeAN8ScansPerRead            "eAN8ScansPerRead"
#define PosNuPCAScansPerRead            "uPCAScansPerRead"
#define PosNuPCDScansPerRead            "uPCDScansPerRead"
#define PosNuPCEScansPerRead            "uPCEScansPerRead"
#define PosNstoreScansPerRead           "storeScansPerRead"
#define PosNsupplementals               "supplementals"
#define PosNtransmitCheckDigit          "transmitCheckDigit"
#define PosNtwoLabelFlagPair1           "twoLabelFlagPair1"
#define PosNtwoLabelFlagPair2           "twoLabelFlagPair2"
#define PosNtwoLabelFlagPair3           "twoLabelFlagPair3"
#define PosNtwoLabelFlagPair4           "twoLabelFlagPair4"
#define PosNuPCExpansion                "uPCExpansion"
#define PosNverifyPriceChk              "verifyPriceChk"


/****************************/
/* Scanner resource classes */
/****************************/

#define PosCBarCodes1                   "BarCodes1"
#define PosCBarCodes2                   "BarCodes2"
#define PosCBarCodes3                   "BarCodes3"
#define PosCBarCodes4                   "BarCodes4"
#define PosCBarCodeProgramming          "BarCodeProgramming"
#define PosCBeepFreq                    "BeepFreq"
#define PosCBeepLength                  "BeepLength"
#define PosCBeepState                   "BeepState"
#define PosCBeepVolume                  "BeepVolume"
#define PosCBlinkLength                 "BlinkLength"
#define PosCBlock1Type                  "Block1Type"
#define PosCBlock2Type                  "Block2Type"
#define PosCBlock3Type                  "Block3Type"
#define PosCBlockReadMode               "BlockReadMode"
#define PosCBVolSwitchState             "BVolSwitchState"
#define PosCCheckModulo                 "CheckModulo"
#define PosCCode128ScansPerRead         "Code128ScansPerRead"
#define PosCCode39ScansPerRead          "Code39ScansPerRead"
#define PosCDecodeAlgorithm             "DecodeAlgorithm"
#define PosCDReadTimeout                "DReadTimeout"
#define PosCDTouchMode                  "DTouchMode"
#define PosCITFLength1                  "ITFLength1"
#define PosCITFLength2                  "ITFLength2"
#define PosCITFLengthType               "ITFLengthType"
#define PosCITFScansPerRead             "ITFScansPerRead"
#define PosCJANTwoLabelDecode           "JANTwoLabelDecode"
#define PosCLabelsQueued                "LabelsQueued"
#define PosCLaserTimeout                "LaserTimeout"
#define PosCMotorTimeout                "MotorTimeout"
#define PosCLaserSwitchState            "LaserSwitchState"
#define PosCQueueAllLabels              "QueueAllLabels"
#define PosCScansPerRead                "ScansPerRead"
#define PosCEAN13ScansPerRead           "EAN13ScansPerRead"
#define PosCEAN8ScansPerRead            "EAN8ScansPerRead"
#define PosCUPCAScansPerRead            "UPCAScansPerRead"
#define PosCUPCDScansPerRead            "UPCDScansPerRead"
#define PosCUPCEScansPerRead            "UPCEScansPerRead"
#define PosCStoreScansPerRead           "StoreScansPerRead"
#define PosCSupplementals               "Supplementals"
#define PosCTransmitCheckDigit          "TransmitCheckDigit"
#define PosCTwoLabelFlagPair1           "TwoLabelFlagPair1"
#define PosCTwoLabelFlagPair2           "TwoLabelFlagPair2"
#define PosCTwoLabelFlagPair3           "TwoLabelFlagPair3"
#define PosCTwoLabelFlagPair4           "TwoLabelFlagPair4"
#define PosCUPCExpansion                "UPCExpansion"
#define PosCVerifyPriceChk              "VerifyPriceChk"



/*********************************************************************/
/*                                                                   */
/* This block comment describes how the constants for the bar code   */
/* types and groups are built.  Each distinct bar code type is       */
/* assigned a bit position (or two) within a 32 bit word.  When a    */
/* bar code of that type is read, the appropriate field in the data  */
/* buffer is filled with a value that has that bit set.  When a      */
/* scanner is being configured to read a group of bar codes, the     */
/* bit(s) corresponding to the bar code(s) read in that mode are     */
/* set.  There is also an "odd mode" bit that is used when the mode  */
/* or bar code does not fit the normal set of rules.                 */
/*                                                                   */
/* In the figure, the 1's indicate a set bit while the periods       */
/* indicate a clear bit.  The bit positions were chosen like this    */
/* so it would be a little easier to remember the bit positions      */
/* while debugging.                                                  */
/*                                                                   */
/*********************************************************************/
/*                                                                   */
/*                          Bit 31                            Bit 0  */
/*        Label Type        |             Bit(s) set              |  */
/*  ---------------------   ---------------------------------------  */
/*  (Unknown)               .... .... .... .... .... .... .... ....  */
/*                                                                   */
/*  UCC/EAN 128             .... .... ...1 .... .... .... .... ....  */
/*                                                                   */
/*  Codabar                 .... .... .... 1... .... .... .... ....  */
/*  Code 39                 .... .... .... .1.. .... .... .... ....  */
/*  Code 93                 .... .... .... ..1. .... .... .... ....  */
/*  Code 128                .... .... .... ...1 .... .... .... ....  */
/*                                                                   */
/*  UPC-A                   .... .... .... .... 1... .... .... ....  */
/*  UPC-E                   .... .... .... .... .1.. .... .... ....  */
/*  EAN-8                   .... .... .... .... ..1. .... .... ....  */
/*  EAN-13                  .... .... .... .... ...1 .... .... ....  */
/*                                                                   */
/*  UPC-D1                  .... .... .... .... .... 1... .... ....  */
/*  UPC-D2                  .... .... .... .... .... .1.. .... ....  */
/*  UPC-D3                  .... .... .... .... .... ..1. .... ....  */
/*  UPC-D4                  .... .... .... .... .... ...1 .... ....  */
/*  UPC-D5                  .... .... .... .... .... .... 1... ....  */
/*                                                                   */
/*  Interleaved 2 of 5      .... .... .... .... .... .... .... 1...  */
/*  Standard 2 of 5         .... .... .... .... .... .... .... .1..  */
/*                                                                   */
/*  Plus 2 (flag)           .... .... .... .... .... .... .... ..1.  */
/*  Plus 5 (flag)           .... .... .... .... .... .... .... ...1  */
/*  Plus 128 (flag)         .... .... .... .... .... .... ...1 ....  */
/*                                                                   */
/*  "Odd" modes             1... .... .... .... .... .... .... ....  */
/*                                                                   */
/*  (Reserved)              .111 1111 111. .... .... .... .11. ....  */
/*                                                                   */
/*  Labels with multiple bits set:                                   */
/*                                                                   */
/*  UPC-A+2                 .... .... .... .... 1... .... .... ..1.  */
/*  UPC-A+5                 .... .... .... .... 1... .... .... ...1  */
/*  UPC-A+Code 128          .... .... .... .... 1... .... ...1 ....  */
/*  UPC-E+2                 .... .... .... .... .1.. .... .... ..1.  */
/*  UPC-E+5                 .... .... .... .... .1.. .... .... ...1  */
/*  UPC-E+Code 128          .... .... .... .... .1.. .... ...1 ....  */
/*  EAN-8+2                 .... .... .... .... ..1. .... .... ..1.  */
/*  EAN-8+5                 .... .... .... .... ..1. .... .... ...1  */
/*  EAN-8+Code 128          .... .... .... .... ..1. .... ...1 ....  */
/*  EAN-13+2                .... .... .... .... ...1 .... .... ..1.  */
/*  EAN-13+5                .... .... .... .... ...1 .... .... ...1  */
/*  EAN-13+Code 128         .... .... .... .... ...1 .... ...1 ....  */
/*                                                                   */
/*********************************************************************/


/***************************************************/
/* PosNbarCodes1-4 resource values                 */
/***************************************************/

#define PosLGROUP_UCC_EAN_128           0x00100000L
#define PosLGROUP_CODABAR               0x00080000L
#define PosLGROUP_CODE_39               0x00040000L
#define PosLGROUP_CODE_93               0x00020000L
#define PosLGROUP_CODE_128              0x00010000L
#define PosLGROUP_INT_2_OF_5            0x00000008L
#define PosLGROUP_NONE                  0x00000000L
#define PosLGROUP_PLUS_2_5_ONLY         0x8000F003L
#define PosLGROUP_STD_2_OF_5            0x00000004L
#define PosLGROUP_UPC_D1_TO_D5          0x00000F80L
#define PosLGROUP_UPC_EAN               0x0000F000L

#define PosLGROUP_UPC_EAN_CODABAR       0x0008F000L
#define PosLGROUP_UPC_EAN_CODE_39       0x0004F000L
#define PosLGROUP_UPC_EAN_CODE_93       0x0002F000L
#define PosLGROUP_UPC_EAN_CODE_128      0x0001F000L
#define PosLGROUP_UPC_EAN_D1_TO_D5      0x0000FF80L
#define PosLGROUP_UPC_EAN_D3            0x0000F200L
#define PosLGROUP_UPC_EAN_ITF           0x0000F008L

#define PosLGROUP_UPC_EAN_PLUS_2        0x0000F002L
#define PosLGROUP_UPC_EAN_PLUS_5        0x0000F001L
#define PosLGROUP_UPC_EAN_PLUS_2_5      0x0000F003L
#define PosLGROUP_UPC_EAN_2_5_CODABAR   0x0008F003L

#define PosLGROUP_UCC_EAN_128_CODABAR   0x00180000L
#define PosLGROUP_UCC_EAN_128_CODE_39   0x00140000L
#define PosLGROUP_UCC_EAN_128_CODE_93   0x00120000L
#define PosLGROUP_UCC_EAN_128_CODE_128  0x00110000L
#define PosLGROUP_UCC_EAN_128_ITF       0x00100008L
#define PosLGROUP_CODABAR_CODE_39       0x000C0000L
#define PosLGROUP_CODABAR_CODE_93       0x000A0000L
#define PosLGROUP_CODABAR_CODE_128      0x00090000L
#define PosLGROUP_CODABAR_ITF           0x00080008L
#define PosLGROUP_CODE_39_CODE_93       0x00060000L
#define PosLGROUP_CODE_39_CODE_128      0x00050000L
#define PosLGROUP_CODE_39_ITF           0x00040008L
#define PosLGROUP_CODE_93_CODE_128      0x00030000L
#define PosLGROUP_CODE_93_ITF           0x00020008L
#define PosLGROUP_CODE_128_ITF          0x00010008L
#define PosLGROUP_ALL                   0x001FFF88L


/****************************************************************/
/* PosNblock1Type, PosNblock2Type, and PosNblock3Type resource  */
/* values, as well as the constants used to indicate label type */
/****************************************************************/

#define PosLABEL_UCC_EAN_128            0x00100000L
#define PosLABEL_CODABAR                0x00080000L
#define PosLABEL_CODE_39                0x00040000L
#define PosLABEL_CODE_93                0x00020000L
#define PosLABEL_CODE_128               0x00010000L
#define PosLABEL_EAN_8                  0x00002000L
#define PosLABEL_EAN_8_PLUS_2           0x00002002L
#define PosLABEL_EAN_8_PLUS_5           0x00002001L
#define PosLABEL_EAN_8_PLUS_CODE128     0x00002010L
#define PosLABEL_EAN_13                 0x00001000L
#define PosLABEL_EAN_13_PLUS_2          0x00001002L
#define PosLABEL_EAN_13_PLUS_5          0x00001001L
#define PosLABEL_EAN_13_PLUS_CODE128    0x00001010L
#define PosLABEL_INT_2_OF_5             0x00000008L
#define PosLABEL_NO_CHECK               0x00000000L
#define PosLABEL_STD_2_OF_5             0x00000004L
#define PosLABEL_UNKNOWN                0x00000000L
#define PosLABEL_UPC_A                  0x00008000L
#define PosLABEL_UPC_A_PLUS_2           0x00008002L
#define PosLABEL_UPC_A_PLUS_5           0x00008001L
#define PosLABEL_UPC_A_PLUS_CODE128     0x00008010L
#define PosLABEL_UPC_D1                 0x00000800L
#define PosLABEL_UPC_D2                 0x00000400L
#define PosLABEL_UPC_D3                 0x00000200L
#define PosLABEL_UPC_D4                 0x00000100L
#define PosLABEL_UPC_D5                 0x00000080L
#define PosLABEL_UPC_E                  0x00004000L
#define PosLABEL_UPC_E_PLUS_2           0x00004002L
#define PosLABEL_UPC_E_PLUS_5           0x00004001L
#define PosLABEL_UPC_E_PLUS_CODE128     0x00004010L

#define PosLABEL_PLUS_2_FLAG            0x00000002L
#define PosLABEL_PLUS_5_FLAG            0x00000001L
#define PosLABEL_PLUS_CODE128_FLAG      0x00000010L

/*****************************************************/
/* Resource values used by scanner devices for       */
/* PosNblinkLength, PosNbeepLength, PosNdReadTimeout */
/*****************************************************/

#define PosSHORT                        0x00
#define PosMEDLONG                      0x01
#define PosLONG                         0x02
#define PosLONGEST                      0x03


/*****************************************************/
/* Resource values used by scanner devices for       */
/* PosNuPCExpansion.                                 */
/*****************************************************/

#define PosNO_EXPANSION                 0x00
#define PosUPCA_TO_EAN13                0x01
#define PosUPCE_TO_EAN13                0x02
#define PosUPCA_UPCE_TO_EAN13           0x03
#define PosUPCE_TO_UPCA                 0x04
#define PosUPCE_TO_UPCA_TO_EAN13        0x05


/*****************************************************/
/* Resource values used by scanner devices for       */
/* PosNverifyPriceChk.                               */
/*****************************************************/

#define PosNO_VERIFY                    0x00
#define PosVERIFY_4DIGIT                0x01
#define PosVERIFY_5DIGIT                0x02


/*****************************************************/
/* Resource values used by scanner devices for       */
/* PosNcheckModulo. Note that scanners use PosENABLE */
/* to enable all check digits and PosDISABLE to      */
/* disable all check digits.  These only apply to    */
/* USB scanners.                                     */
/*****************************************************/

#define PosNO_CHECK_DIGITS                   0x00
#define PosUPCA_CHECK_DIGIT                  0x02
#define PosUPCE_CHECK_DIGIT                  0x04
#define PosUPCE_UPCA_CHECK_DIGIT             0x06
#define PosCODE39_CHECK_DIGIT                0x08
#define PosCODE39_UPCA_CHECK_DIGIT           0x0A
#define PosCODE39_UPCE_CHECK_DIGIT           0x0C
#define PosCODE39_UPCE_UPCA_CHECK_DIGIT      0x0E
#define PosITF_CHECK_DIGIT                   0x10
#define PosITF_UPCA_CHECK_DIGIT              0x12
#define PosITF_UPCE_CHECK_DIGIT              0x14
#define PosITF_UPCE_UPCA_CHECK_DIGIT         0x16
#define PosITF_CODE39_CHECK_DIGIT            0x18
#define PosITF_CODE39_UPCA_CHECK_DIGIT       0x1A
#define PosITF_CODE39_UPCE_CHECK_DIGIT       0x1C
#define PosALL_CHECK_DIGITS                  0x01  // For USB compatibilty with HHBCR


/*****************************************************/
/* Resource values used by scanner devices for       */
/* PosNsupplementals.                                */
/*****************************************************/

#define PosNO_SUPPLEMENTALS                  0x00
#define PosPLUS_2_SUPPLEMENTALS              0x01
#define PosPLUS_5_SUPPLEMENTALS              0x02
#define PosPLUS_2_5_SUPPLEMENTALS            0x03
#define PosPLUS_CODE128_SUPPLEMENTALS        0x04
#define PosPLUS_2_CODE128_SUPPLEMENTALS      0x05
#define PosPLUS_5_CODE128_SUPPLEMENTALS      0x06
#define PosALL_SUPPLEMENTALS                 0x07


/*****************************************************/
/* Resource values used by scanner devices for       */
/* PosNiTFLengthType                                 */
/*****************************************************/

#define PosDISCRETE                     0x00
#define PosRANGE                        0x01

/***************************************************************/
/* Constants used in the Flags field of the scanner data block */
/***************************************************************/

#define POS_SCAN_LAST_BLOCK              0x0001
#define POS_SCAN_UNEXPECTED_DATA         0x0002
#define POS_SCAN_PARTIAL_LABEL           0x0004
#define POS_SCAN_LABEL_READ_ERROR        0x0008
#define POS_SCAN_DIRECT_IO_RESPONSE      0x0010
#define POS_SCAN_DIRECT_IO_ERROR         0x0020
#define POS_SCAN_UNEXPECTED_LENGTH       0x0040


/****************************************************************/
/* PosScannerDataHdr structure -- Scanner label data header     */
/****************************************************************/

typedef struct
  {
    unsigned long  LblType;             /* Label Type   */
    unsigned short Flags;               /* Flags        */
    unsigned short LblLen;              /* Label Length */
  } PosScannerDataHdr;


#endif   /* _H_POS_SCANNER */
