/* @(#)39       1.1.1.1  src/include/pos/touch.h, apicode, ptuxrolo, 35 10/8/02 17:25:03 */

/********************************************************************/
/*  <touch.h> header file                                           */
/*                                                                  */
/*  Licensed Materials - Property of IBM                            */
/*                                                                  */
/*  IBM Point of Sale Subsystem                                     */
/*  73G0950 (C) Copyright IBM Corporation 1994, 1995                */
/*  All rights reserved                                             */
/*                                                                  */
/*  US Government Users Restricted Rights -                         */
/*  Use, duplication, or disclosure restricted                      */
/*  by GSA ADP Schedule Contract with IBM Corp.                     */
/*                                                                  */
/********************************************************************/

#ifndef _H_POS_TOUCH
#define _H_POS_TOUCH 1

/***************************************************************/
/* Values for the SUBTYPE field of ONLINE and OFFLINE messages */
/***************************************************************/


/* The following 2 names are included in this release for      */
/* compatibility with the previous release only. They are      */
/* being replaced by the more descriptive names which follow.  */
/* They will be removed from this header in a future release.  */


#define PosTOUCH_SUBTYPE_4695_A           1     /* 4695 10.4" mono  */
#define PosTOUCH_SUBTYPE_4695_B           2     /* 4695  9.5" color */

#define PosTOUCH_SUBTYPE_4695_104_M       1     /* 4695 10.4" mono  */
#define PosTOUCH_SUBTYPE_4695_95_C        2     /* 4695  9.5" color */
#define PosTOUCH_SUBTYPE_4695_104_C       3     /* 4695 10.4" color */
#define PosTOUCH_SUBTYPE_4695_121_C       4     /* 4695 12.1" color */

#define PosTOUCH_SUBTYPE_SUREPOINT_95_M  10     /* Sure Point  9.5" mono  */
#define PosTOUCH_SUBTYPE_SUREPOINT_95_C  11     /* Sure Point  9.5" color */
#define PosTOUCH_SUBTYPE_SUREPOINT_104_C 12     /* Sure Point 10.4" color */

#define PosTOUCH_SUBTYPE_4820            13     /* Carlsbad */

/***************************/
/* PosTouch resource names */
/***************************/

#define PosNtouchBackLightOnEvent       "touchBackLightOnEvent"
#define PosNtouchBrightness             "touchBrightness"
#define PosNtouchClickVolume            "touchClickVolume"
#define PosNtouchContrast               "touchContrast"
#define PosNtouchEntryClick             "touchEntryClick"
#define PosNtouchExitClick              "touchExitClick"
#define PosNtouchMaxX                   "touchMaxX"
#define PosNtouchMaxY                   "touchMaxY"
#define PosNtouchMode                   "touchMode"
#define PosNtouchScreenSaverTime        "touchScreenSaverTime"
#define PosNtouchToneDuration           "touchToneDuration"
#define PosNtouchToneFreq               "touchToneFreq"
#define PosNtouchToneVolume             "touchToneVolume"


/**************************/
/* Touch resource classes */
/**************************/

#define PosCTouchBackLightOnEvent       "TouchBackLightOnEvent"
#define PosCTouchBrightness             "TouchBrightness"
#define PosCTouchClickVolume            "TouchClickVolume"
#define PosCTouchContrast               "TouchContrast"
#define PosCTouchEntryClick             "TouchEntryClick"
#define PosCTouchExitClick              "TouchExitClick"
#define PosCTouchMaxX                   "TouchMaxX"
#define PosCTouchMaxY                   "TouchMaxY"
#define PosCTouchMode                   "TouchMode"
#define PosCTouchScreenSaverTime        "TouchScreenSaverTime"
#define PosCTouchToneDuration           "TouchToneDuration"
#define PosCTouchToneFreq               "TouchToneFreq"
#define PosCTouchToneVolume             "TouchToneVolume"


/*********************************/
/* PosNtouchMode resource values */
/*********************************/

#define PosTOUCH_MODE_TRACKING          0x01
#define PosTOUCH_MODE_ENTER             0x02
#define PosTOUCH_MODE_EXIT              0x04


/*************************/
/* POSM_TOUCH_DATA flags */
/*************************/

#define PosTOUCH_BUTTON1_DOWN           0x0001
#define PosTOUCH_ERROR                  0x0010

//-----------------------------------
// Request values used with PosIOCtl.
//-----------------------------------
#define POS_TOUCH_MTS_CALIBRATE       (6700 + 3)
#define POS_TOUCH_MTS_RESET           (6700 + 4)
#define POS_TOUCH_MTS_NATIVE		 (6700 + 5)
#define POS_TOUCH_MTS_EMULATION	 (6700 + 6)
  
//--------------------------------------
// Event values used on the input queue.
//--------------------------------------
#define POSM_TOUCH_MTS_COMMAND        (POSM_MSG_BASE + 27)


#endif   /* _H_POS_TOUCH */

